/**
 * @module
 * @public
 * @description
 * The `di` module provides dependency injection container services.
 */
library angular2.di;

export "src/di/annotations.dart"
    show
        InjectAnnotation,
        OptionalAnnotation,
        InjectableAnnotation,
        DependencyAnnotation,
        VisibilityAnnotation,
        SelfAnnotation,
        ParentAnnotation,
        AncestorAnnotation,
        UnboundedAnnotation;
export "src/di/decorators.dart"
    show
        Inject,
        Optional,
        Injectable,
        Visibility,
        Self,
        Parent,
        Ancestor,
        Unbounded;
export "src/di/annotations_impl.dart" show self;
export "src/di/forward_ref.dart"
    show forwardRef, resolveForwardRef, ForwardRefFn;
export "src/di/injector.dart"
    show
        resolveBindings,
        Injector,
        ProtoInjector,
        PUBLIC_AND_PRIVATE,
        PUBLIC,
        PRIVATE,
        undefinedValue;
export "src/di/binding.dart"
    show Binding, BindingBuilder, ResolvedBinding, Dependency, bind;
export "src/di/key.dart" show Key, KeyRegistry, TypeLiteral;
export "src/di/exceptions.dart"
    show
        NoBindingError,
        AbstractBindingError,
        AsyncBindingError,
        CyclicDependencyError,
        InstantiationError,
        InvalidBindingError,
        NoAnnotationError,
        OutOfBoundsError;
export "src/di/opaque_token.dart" show OpaqueToken;
